<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
    xmlns:sch="http://purl.oclc.org/dsdl/schematron" xmlns="http://www.w3.org/1999/xhtml">
    <xd:doc xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl" scope="stylesheet">
        <xd:desc>
            <xd:p><xd:b>Created on:</xd:b> Mar 2, 2010</xd:p>
            <xd:p><xd:b>Author:</xd:b> bobj</xd:p>
                                                                                                                                                                  <xd:p/>
        </xd:desc>
    </xd:doc>

    <xsl:output method="html" doctype-public="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dxsl:patd"/>

    <xsl:param name="section">3</xsl:param>
    
    <xsl:template match="/">
        <html xmlns="http://www.w3.org/1999/xhtml">
            <head>
                <link rel="stylesheet" type="text/css" href="sdmx-hd.css" />
                <style type="text/css">
                    BODY {
                        counter-reset: chapter <xsl:value-of select="$section - 1"/>;
                        /* Create a section counter scope */
                    }
                </style>
            </head>
            <body>
                <xsl:apply-templates/>
            </body>
        </html>
    </xsl:template>

    <xsl:template match="sch:title"/>

    <xsl:template match="sch:p">
        <p>
            <xsl:apply-templates/>
        </p>
    </xsl:template>

    <xsl:template match="sch:schema">
        <h1>
            <xsl:value-of select="sch:title"/>
        </h1>
        <xsl:apply-templates select="sch:p"/>
 
        <xsl:if test="xsl:key">
            <div>
            <h2>XSL keys referenced</h2>
            <table>
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Match</th>
                            <th>Use</th>
                        </tr>
                    </thead>
                <xsl:for-each select="xsl:key">
                    <tr>
                        <td>
                            <xsl:value-of select="@name"/>
                        </td>
                        <td>
                            <xsl:value-of select="@match"/>
                        </td>
                        <td>
                            <xsl:value-of select="@use"/>
                        </td>
                    </tr>
                </xsl:for-each>
            </table>
        </div>
        </xsl:if>
        <div class="namespaces">
            <h2>Namespaces referenced</h2>
            <table border="1">
                    <thead>
                        <tr>
                        <th>Prefix</th>
                        <th>URI</th>
                        </tr>
                    </thead>
                <xsl:for-each select="sch:ns">
                    <tr>
                        <td>
                            <xsl:value-of select="@prefix"/>
                        </td>
                        <td>
                            <xsl:value-of select="@uri"/>
                        </td>
                    </tr>
                </xsl:for-each>
            </table>
        </div>
        <xsl:apply-templates select="sch:pattern"/>
    </xsl:template>

    <xsl:template match="sch:pattern">
        <h2>
            <xsl:value-of select="sch:title"/>
        </h2>
            <xsl:apply-templates/>
    </xsl:template>

    <xsl:template match="sch:rule">
        <div class="rule">
            <h3><xsl:value-of select="@role"/></h3>
            <div class="code">
                <p><em>Context</em>: <xsl:value-of select="@context"/></p>
            <xsl:if test="sch:let">
                <xsl:for-each select="sch:let">
                    <p><em>Variable</em>: <xsl:value-of select="@name"/> = <xsl:value-of select="@value"/></p> 
                </xsl:for-each>
            </xsl:if> </div>
            <ol type="a">
                <xsl:apply-templates/>
            </ol>
        </div>
    </xsl:template>

    <xsl:template match="sch:assert">
        <li>
            <p>
                <xsl:value-of select="."/>
            </p>
            <div class="code"><em>Test</em>: <xsl:value-of select="@test"/></div>
        </li>
    </xsl:template>

</xsl:stylesheet>
